﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;


namespace Counter
{
    class Program
    {
        static void Main(string[] args)
        {
            int Dev_Index = 0;
            int temp;
            double temp1;
            byte CtrNum =15;
            byte CtrMode = 0;
            byte CtrEdge = 1;
            byte OnOff = 1;
            temp = usb1000.OpenDevice(Dev_Index);           //打开设备
            temp = usb1000.ResetDevice(Dev_Index);		    //复位指定设备   
            temp = usb1000.SetCounter(Dev_Index,CtrNum,CtrMode,CtrEdge);         
            //设置计数器功能 
            /*CtrNum，计数器通道索引号。0~3 对应 Ct0~Ct3。如果设置 0x0f 表示 4 个通道计
              数器同时操作。
              CtrMode，计数器工作模式，0 表示事件计数器模式，1 表示测量周期，2 表示测
              量正脉宽，3 表示测量负脉宽。
              CtrEdge，当工作于事件计数器模式时，本参数为 1 表示计数上升沿，2 表示计数
              下降沿。
              返回值：0 为无错
             */
            temp = usb1000.StartCounter(Dev_Index,CtrNum,OnOff);  //设置计数器工作开关  启动或者停止计数器    OnOFF 1表示启动计数器 0表示停止计数器
            temp = usb1000.StartRead(Dev_Index);                    //启动读数。本函数将自动启用一个线程，自动将采集卡硬件 FIFO 中的数据读回来存储计算机的软件 FIFO 中。
            temp = usb1000.TransDioIn(Dev_Index,1);               //单独使用计数器或者数字量功能时 需要开启此函数
            for (int i = 0; i < 100; i++)
            {
                
                for (byte y = 0; y < 4; y++)
                {
                   temp = usb1000.GetCounter(Dev_Index,y);       //计数器模式下 获取计数的值           函数返回值为计数值
                   //temp1 = usb1000.GetCtrTime(Dev_Index, y);    //计数器模式下获取周期 以ns为单位    函数返回值为周期
                   Console.WriteLine(temp);
                }
                Thread.Sleep(50);
            }


            temp = usb1000.TransDioIn(Dev_Index,0);
            temp = usb1000.StartCounter(Dev_Index, CtrNum, 0);
            temp = usb1000.StopRead(Dev_Index);
            usb1000.CloseDevice(Dev_Index);
        }
    }
    class usb1000
    {
        [DllImport("usb1000.dll")]
        public static extern int FindUSBDAQ();
        [DllImport("usb1000.dll")]
        public static extern int OpenDevice(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int USB1GetDeviceSN(int DevIndex, byte[] SN);
        [DllImport("usb1000.dll")]
        public static extern int ResetDevice(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern void CloseDevice(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int SetUSB1AiRange(int DevIndex, float Range);
        [DllImport("usb1000.dll")]
        public static extern int SetSampleRate(int DevIndex, uint SampleRate);
        [DllImport("usb1000.dll")]
        public static extern int SetChanSel(int DevIndex, UInt16 ChSel);
        [DllImport("usb1000.dll")]
        public static extern int SetChanMode(int DevIndex, byte ChanMode);
        [DllImport("usb1000.dll")]
        public static extern int SetTrigSource(int DevIndex, byte TrigSource);
        [DllImport("usb1000.dll")]
        public static extern int SetSoftTrig(int DevIndex, byte Trig);
        //public static extern int SetTrigEdge(int DevIndex, byte TrigEdge);
        [DllImport("usb1000.dll")]
        public static extern int ClearTrigger(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int SetDioOut(int DevIndex, int DioOut);
        [DllImport("usb1000.dll")]
        public static extern int GetDioIn(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int TransDioIn(int DevIndex, byte TransDioSwitch);
        [DllImport("usb1000.dll")]
        public static extern int SetCounter(int DevIndex, byte CtrNum, byte CtrMode, byte CtrEdge);
        [DllImport("usb1000.dll")]
        public static extern int StartCounter(int DevIndex, byte CtrNum, byte OnOff);
        [DllImport("usb1000.dll")]
        public static extern int GetCounter(int DevIndex, byte CtrNum);
        [DllImport("usb1000.dll")]
        public static extern double GetCtrTime(int DevIndex, byte CtrNum);
        //public static extern int InitDA(int DevIndex);

        //public static extern int SetDA(int DevIndex, byte DANum, float DAVolt);

        //public static extern int SetWavePt(int DevIndex, byte DANum, float DAVolt);

        //public static extern int ClrWavePt(int DevIndex, byte DANum);

        //public static extern int SetWaveSampleRate(int DevIndex, uint WaveSampleRate);

        // public static extern int WaveOutput(int DevIndex, byte DANum);

        [DllImport("usb1000.dll")]
        public static extern int ClearBufs(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int ClearCounter(int DevIndex, byte CtrNum);
        [DllImport("usb1000.dll")]
        public static extern int StartRead(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int StopRead(int DevIndex);
        [DllImport("usb1000.dll")]
        public static extern int GetAiChans(int DevIndex, int Num, UInt16 ChSel, float[] Ai, int TimeOut);
    }
}
