﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace USB_1000_AI_Continuous_And_DIO
{
    class Program
    {
        static void Main(string[] args)
        {
          
            int Dev_Index = 0;
            int temp;
            int DI;
            float[] Ai = new float[80000];


            temp = usb1000.OpenDevice(Dev_Index);           //打开设备
            temp = usb1000.ResetDevice(Dev_Index);		    //复位指定设备   
            temp = usb1000.SetUSB1AiRange(Dev_Index, 5); 	  // 设置模拟输入量程 这里设置为5代表正负5v量程
            temp = usb1000.SetSampleRate(Dev_Index, 1000);	  //设置总采样率采样率为1K 
            temp = usb1000.SetChanMode(Dev_Index, 1);         //选择接线方式 0代表diff  1代表NRSE 3代表RSE  其它无效
            temp = usb1000.SetChanSel(Dev_Index, 0x01);		 // 选择需要采集的通道  以二进制表示 这里选择开启0通道  AI功能 一共16通道低位到高位依次是 Ai1到Ai15
            temp = usb1000.StartRead(Dev_Index);             //开启线程      
            //temp = usb1000.TransDioIn(Dev_Index, 1);       //使用数字功能需要调用此函数，1打开，0关闭
            temp = usb1000.SetSoftTrig(Dev_Index, 1);        //设置软件触发

            //若需要进行连续采集 则可以连读不断执行getai函数即可
            for (int i = 0; i < 10; i++)
            {
                temp = usb1000.GetAiChans(Dev_Index, 100, 1, Ai, 1000);
                // 每通道读取 100个点存放于 Ai 数组中，超时时间为 1000ms
                // 数据存放规则为前 100个数据是 Ai 0 通道；
                //          接下来 100个数据是 Ai 1 通道；
                //          接下来 100 个数据是 Ai 2 通道；
                // 依此类推。
                Console.WriteLine(Ai[0]);
                Console.WriteLine(temp);
                // Console.WriteLine(temp);
                temp = usb1000.SetDioOut(Dev_Index, 65535);     //设置数字输出功能，给的值是65535 代表16通道输出高电平，2的16次方，需要开启某些通道，可根据2进制进行换算十进制
                DI = usb1000.GetDioIn(Dev_Index);                //次函数返回值是DI数字输出结果，次函数这里返回65535，2的16次方，16通道都是高电平，采集默认di通道都是高电平， DIDO输出高是3.3，采集识别是3.3到5是高，0到1.2是低
                Console.WriteLine(DI);
            }
            temp = usb1000.SetSoftTrig(Dev_Index, 0);
            temp = usb1000.StopRead(Dev_Index);			    //停止线程 
            usb1000.CloseDevice(Dev_Index);                 //关闭采集卡设备
            //上述是控制台程序可以依据断点判断DI数值，万用表判断do输出准确性。
        }
        class usb1000
        {
            [DllImport("usb1000.dll")]
            public static extern int FindUSBDAQ();
            [DllImport("usb1000.dll")]
            public static extern int OpenDevice(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int USB1GetDeviceSN(int DevIndex, byte[] SN);
            [DllImport("usb1000.dll")]
            public static extern int ResetDevice(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern void CloseDevice(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int SetUSB1AiRange(int DevIndex, float Range);
            [DllImport("usb1000.dll")]
            public static extern int SetSampleRate(int DevIndex, uint SampleRate);
            [DllImport("usb1000.dll")]
            public static extern int SetChanSel(int DevIndex, UInt16 ChSel);
            [DllImport("usb1000.dll")]
            public static extern int SetChanMode(int DevIndex, byte ChanMode);
            [DllImport("usb1000.dll")]
            public static extern int SetTrigSource(int DevIndex, byte TrigSource);
            [DllImport("usb1000.dll")]
            public static extern int SetSoftTrig(int DevIndex, byte Trig);
            //public static extern int SetTrigEdge(int DevIndex, byte TrigEdge);
            [DllImport("usb1000.dll")]
            public static extern int ClearTrigger(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int SetDioOut(int DevIndex, int DioOut);
            [DllImport("usb1000.dll")]
            public static extern int GetDioIn(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int TransDioIn(int DevIndex, byte TransDioSwitch);

            //public static extern int SetCounter(int DevIndex, byte CtrNum, byte CtrMode, byte CtrEdge);

            // public static extern int StartCounter(int DevIndex, byte CtrNum, byte OnOff);

            //public static extern int InitDA(int DevIndex);

            //public static extern int SetDA(int DevIndex, byte DANum, float DAVolt);

            //public static extern int SetWavePt(int DevIndex, byte DANum, float DAVolt);

            //public static extern int ClrWavePt(int DevIndex, byte DANum);

            //public static extern int SetWaveSampleRate(int DevIndex, uint WaveSampleRate);

            // public static extern int WaveOutput(int DevIndex, byte DANum);

            [DllImport("usb1000.dll")]
            public static extern int ClearBufs(int DevIndex);
            //public static extern int ClearCounter(int DevIndex, byte CtrNum);
            [DllImport("usb1000.dll")]
            public static extern int StartRead(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int StopRead(int DevIndex);
            [DllImport("usb1000.dll")]
            public static extern int GetAiChans(int DevIndex, int Num, UInt16 ChSel, float[] Ai, int TimeOut);
           }
        }
    }

